freeslot("SPR_INFK", "MT_SKIN_TYINFINITE_CUBE", "S_SKIN_TYINFINITE_CUBE1", "S_SKIN_TYINFINITE_CUBE2", "S_SKIN_TYINFINITE_CUBE3")

local MOVEMENT_RATE_P = 48
local MOVEMENT_RATE_H = 2
local MOVEMENT_RATE_V = 4
local SKIN_NAME = "zeros"

mobjinfo[MT_SKIN_TYINFINITE_CUBE] = {
        spawnstate = S_SKIN_TYINFINITE_CUBE1,
        spawnhealth = 1000,
        radius = 1*FRACUNIT,
        height = 1*FRACUNIT,
        flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT,
}

states[S_SKIN_TYINFINITE_CUBE1] = {SPR_INFK, A|TR_TRANS20, TICRATE / 2, nil, 0, 0, S_NULL}
states[S_SKIN_TYINFINITE_CUBE2] = {SPR_INFK, B|TR_TRANS20, TICRATE / 2, nil, 0, 0, S_NULL}
states[S_SKIN_TYINFINITE_CUBE3] = {SPR_INFK, C|TR_TRANS20, TICRATE / 2, nil, 0, 0, S_NULL}

local function shouldMakeParticals(p)
	-- for future in-case more cases should be added
	return (p.kartstuff[k_spinouttimer] > 0)
end

local function cubes(pmo)
	if pmo and pmo.valid and pmo.player and pmo.player.valid and pmo.skin == SKIN_NAME then
		local p = pmo.player
		
		if shouldMakeParticals(p) and leveltime % (TICRATE / 16) == 0 then
			local c = P_SpawnMobj(pmo.x + FixedMul((MOVEMENT_RATE_P * (FRACUNIT / 2)) - P_RandomFixed() * (MOVEMENT_RATE_P), mapobjectscale),
								  pmo.y + FixedMul((MOVEMENT_RATE_P * (FRACUNIT / 2)) - P_RandomFixed() * (MOVEMENT_RATE_P), mapobjectscale),
								  pmo.z, MT_SKIN_TYINFINITE_CUBE)
			c.tracer = pmo
			c.mx = FixedMul((MOVEMENT_RATE_H * (FRACUNIT / 2)) - P_RandomFixed() * MOVEMENT_RATE_H, mapobjectscale)
			c.my = FixedMul((MOVEMENT_RATE_H * (FRACUNIT / 2)) - P_RandomFixed() * MOVEMENT_RATE_H, mapobjectscale)
			c.mz = FixedMul(((P_RandomFixed() * MOVEMENT_RATE_V) + (FRACUNIT * 2)) * P_MobjFlip(pmo), mapobjectscale)
			c.state = S_SKIN_TYINFINITE_CUBE1 + P_RandomKey(3)
			c.scale = $ * 2
		end
	end
end
addHook("MobjThinker", cubes, MT_PLAYER)

local function cubeThink(mo)
	local g = P_SpawnGhostMobj(mo)
	g.fuse = $ / 2
	if mo.tracer and mo.tracer.valid then
		mo.momx = mo.tracer.momx + mo.mx
		mo.momy = mo.tracer.momy + mo.my
		mo.momz = mo.tracer.momz + mo.mz
		g.momx = $ + mo.tracer.momx
		g.momy = $ + mo.tracer.momy
		g.momz = $ + mo.tracer.momz
	else
		mo.momx = mo.mx
		mo.momy = mo.my
		mo.momz = mo.mz
	end
	mo.mz = $ + FixedMul(P_MobjFlip(mo) * (gravity / 3), mapobjectscale)
	
	if mo.tics < 8 then
		mo.frame = $ & ~FF_TRANSMASK
		mo.frame = $ | (((8 - mo.tics) + 2) << FF_TRANSSHIFT)
	end
	
	P_TeleportMove(mo, mo.x + FixedMul((MOVEMENT_RATE_H * (FRACUNIT / 2)) - P_RandomFixed() * MOVEMENT_RATE_H, mapobjectscale),
					   mo.y + FixedMul((MOVEMENT_RATE_H * (FRACUNIT / 2)) - P_RandomFixed() * MOVEMENT_RATE_H, mapobjectscale),
					   mo.z + FixedMul((MOVEMENT_RATE_H * (FRACUNIT / 2)) - P_RandomFixed() * MOVEMENT_RATE_H, mapobjectscale))
end
addHook("MobjThinker", cubeThink, MT_SKIN_TYINFINITE_CUBE)
